\documentclass[10pt, twocolumn]{article}

\RequirePackage[english]{babel} % lingua italiana
\RequirePackage{times} % carattere times
\RequirePackage{tikz} % pacchetto per fare grafici e disegni
\RequirePackage{url} % Pacchetto per l'inserimento di url 
\RequirePackage{amsmath,amssymb}  % Pacchetto per l'inserimento delle formule matematiche
\usepackage{bbm}
%%%%%%%%%%% Pacchetto che permette l'inserimento di codice Matlab formattato %%%%%
\usepackage{color} % Pacchetto per la gestione del testo colorato
\usepackage{listings} % inserisce listati di programmi
\usepackage{hyperref}
\usepackage{subfig}
%\usepackage[demo]{graphicx}
\definecolor{commenti}{rgb}{0.13,0.55,0.13}
\definecolor{stringhe}{rgb}{0.63,0.125,0.94}
\lstloadlanguages{Matlab}

\lstset{% general command to set parameter(s)
framexleftmargin=4mm,
frame=single,
keywordstyle = \color{blue},% blue keywords
identifierstyle =, % nothing happens
commentstyle = \color{commenti}, % comments
stringstyle = \ttfamily \color{stringhe}, % typewriter type for strings
showstringspaces = false, % no special string spaces
emph = {for, if, then, else, end},
emphstyle = \color{blue},
firstnumber = 1, % numero della prima linea
numbers =left, %  show number_line
numberstyle = \tiny, % style of number_line
stepnumber = 5, % one number_line after stepnumber
numbersep = 5pt,
language = {Matlab}, % per riconoscere la sintassi matlab
extendedchars = true, % per abilitare caratteri particolari
breaklines = true, % per mandare a capo le righe troppo lunghe
breakautoindent = true, % indenta le righe spezzate
breakindent = 30pt, % indenta le righe di 30pt
}

%%% equations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\e}[1]{%
	\ifmmode\refstepcounter{equation}%
	  \eqno\mbox{\rm(\theequation)}\label{e:#1}%
	\else(\ref{e:#1})\fi}

%%% eqalign %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\catcode`@=11
\newdimen\jot \jot=3pt
\def\openup{\afterassignment\@penup\dimen@=}
\def\@penup{\advance\lineskip\dimen@
  \advance\baselineskip\dimen@
  \advance\lineskiplimit\dimen@}
\def\eqalign#1{\null\,\vcenter{\openup\jot\m@th
  \ialign{\strut\hfil$\displaystyle{##}$&$\displaystyle{{}##}$\hfil
      \crcr#1\crcr}}\,}
      
      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{document}

%%%%%%%%%%%%%%% TITOLO %%%%%%%%%%%%%%%%%%%%%

\title{%
  Homework 2 Neural Networks And Deep Learning A.Y 2020/2021 \\
  \large Convolutional AutoEncoder and GAN for MNIST written numbers dataset}
\date{Padova, \today{}}
\author{Michael Neri \\ ID : 1232224}
\maketitle


%%%%%%%%%%%%%%% TESTO %%%%%%%%%%%%%%%%%%%%%
\twocolumn
\section{Introduction}
Second homework is based on \textit{Unsupervised Learning} where training samples are not labelled and the \textit{Neural Network} (NN) has to reduce the dimensionality of samples by representing data in a much more efficient structure.  An example of unsupervised learnink task is \textit{clustering} which consists of separating data in groups (clusters) w.r.t.  correlation. In this homework, we are going to study the behaviour of a \textbf{Convolutional AutoEncoder} using MNIST written numbers dataset. We are going to analyze how to develop a \textbf{Denoising Convolutional Autoencoder} and some examples of its results. We are going to inspect the generated \textit{latent space} using \textbf{t-SNE} (\textit{t-distributed Stochastic Neighbor Embedding} which reduces dimensionality in order to visualize how samples (with and without noise) are distributed in the latent space of the autoencoder.  At the end, we are going to investigate how a \textbf{GAN} (\textit{Generative Adversarial Network}) works and some final results.
\section{Methods}
Our Autoencoder is structured in two main parts: \textbf{Encoder} and \textbf{Decoder} which have specular structure. Encoder accepts gray images of $28\times28$ pixels and outputs a 1D vector of a variable dimension. This dimension defines how much the Autoencoder is compressing the data using a different representation. In other words, we are compressing images into a real-valued vector. This vector then is fed to the Decoder which outputs the reconstructed image. Performance of the total NN (used also as training feedback and \textit{loss}) is measured using the Mean Squared Error between the original image and the reconstructed one, i.e.
\begin{equation}
MSE_{\mathrm{recon}}= \mathcal{L} = \sum_{\forall pixel \in I }^{} (I(pixel) - \hat{I}(pixel))^2
\end{equation}
The structure of the NN Encoder is as follow:

\begin{itemize}
\item Three Convolutional Layers 2D with $\sigma$ activation function ReLU seen in the first HW. At the end of the convolutional part, we have $32 \quad 3\times3$ images of the initial sample;
\item Flatten layer which transforms all the $32$ channels into a 1D vector of dimension $3\times3\times32$ in order to be elaborated by the linear sequence;
\item Two fully-connected layers which computation is to obtain a final 1D vector of dimension equal to the chosen encoded space dimensionality. We apply also a ReLU activation function at the end of the first linear layer.
\end{itemize}

The structure of the Decoder is specular and inverts the Encoder's one:
\begin{itemize}
\item Two fully-connected layers transforms the initial 1D vector into a larger one with $3\times3\times32$ elements;
\item An Unflatten layer which converts the 1D vector into $32$ channels with $3\times3$ images in order to be elaborated by the convolutional part;
\item Three \textbf{Transposed} Convolutional Layers permits to invert the Encoder work in order to manipulate the input tensor into a $28\times28$ gray image. We apply a ReLU activation function to first and second layer;
\item At the end we apply a Sigmoid activation function to the output of the last Transposed Convolutional Layer in order to force the output to be between $0$ and $1$ (because of valid pixel values).
\end{itemize}

\begin{figure}[h!]
\centering
\includegraphics[scale = 0.3]{figures/NoNoiseResults}
\caption{Example of initial and reconstructed image.}
\label{NoNoiseResults}
\end{figure}

\begin{figure}[h!]
\centering
\includegraphics[scale = 0.5]{figures/NoNoiseLossTraining}
\caption{Training Loss (Reconstruction MSE).}
\label{NoNoiseLossTraining}
\end{figure}

During the training phase, both Encoder and Decoder are optimized using Adam with \textit{learning rate} and \textit{weight decay} chosen using \textbf{Grid Search}. 
Thanks to this search, as we can see from Fig.\ref{NoNoiseResults}, our Autoencoder is able to compress MNIST images into tensor of $8$ elements with negligible reconstruction error. In Fig.\ref{NoNoiseLossTraining} we can inspect the dynamics of the training loss on the whole dataset using the best hyperparameters.

\subsection*{Tuning Hyperparameters - Grid Search}
Grid Search is implemented with the same structure of HW1 so discrete values are defined and then all the possible combinations are tested in order to retrieve the best configuration possible for this task. In this environment, this research takes much more time w.r.t. previous homework (take approximately $9$ hours in Google Colab for $96$ combinations) because of the slow training loop.  In Tab.\ref{Tab:1} we define the possible values for each hyperparameter. 

\begin{table}[h!]
\centering
\begin{tabular}{|l|l|}
\cline{1-2}
\textbf{Neurons (Linear Layer)}       & (64,128)        \\ \cline{1-2}
\textbf{Epochs}        & (30,50)       \\ \cline{1-2}
\textbf{Learning Rate} & (1e-3,1e-4)   \\ \cline{1-2}
\textbf{Batch Size}    & (256,512)     \\ \cline{1-2}
\textbf{Weight Decay}    & (1e-4,1e-5)     \\ \cline{1-2}
\textbf{Dimension Latent Space}    & (2,4,8)     \\ \cline{1-2}
\end{tabular}
\caption{List of dicrete values of hyperparameters.}
\label{Tab:1}
\end{table}

Grid Search is applied to the case where no noise is present at the input but the best configuration will be used also for the noisy situation.  Best configuration found is:
\begin{itemize}
\item Neurons = $64$;
\item Epochs = $50$;
\item Learning rate = $1e-3$;
\item Batch Size = $256$;
\item Weight Decay = $1e-5$;
\item Dimension Latent Space = $8$.
\end{itemize}

We have to note that the bigger is the dimension of the latent space, the better the autoencoder works w.r.t. the reconstruction error. If we set a latent space with dimension $28\times28$ then we were only copying the input to the output without any dimensionality reduction.

\subsection*{Denoising Convolutional Autoencoder}
Our autoencoder permits also to remove noise from MNIST images if it is trained properly. We implement two different type of noise in order to corrupt the initial image:
\begin{itemize}
\item \textbf{Gaussian Noise};
\item \textbf{Zero Mask Noise} (Uniform noise with a probability threshold $p$).
\end{itemize}

In this manner, our autoencoder is robust to noisy images with the previous noises.  Some example can be seen in Fig.\ref{DenoisingSamples} where images of test set, corrupted with Gaussian and Zero Mask Noise, are denoised correctly, capturing the main features of the initial image. 

\begin{figure}[h!]
\centering
\includegraphics[scale = 0.3]{figures/DenoisingSamples}
\caption{Example of denoising performances.}
\label{DenoisingSamples}
\end{figure}

From Fig.\ref{DenoisingTraining} we can notice some peaks during training which are caused by the combined noise. This behaviour gets worse if we increase the presence of the noise (w.r.t the mean $\mu$ and the variance $\sigma_{gauss}^2$ of the Gaussian noise and the probability for the Zero Mask one) until no reconstruction is available under some high value of noise.  
\begin{figure}[h!]
\centering
\includegraphics[scale = 0.5]{figures/DenoisingTraining}
\caption{Denoising loss training dynamics.}
\label{DenoisingTraining}
\end{figure}

In general, good performances are obtained with high values of noise using hyperparameters chosen from the Grid Search algorithm.  In order to understand if numbers can be reconstructed properly, we are going to attach a classifier at the end of the autoencoder for valutation purposes. 

\subsection*{Fine-tuning the autoencoder using a classifier}
Attaching a classifier (studied in HW1) to the autoencoder, we can fine-tune the hyperparameters w.r.t. the accuracy of classification. In HW1, we found a CNN which classifies MNIST samples with $99.14\%$ of accuracy on test set. This network will be used at the end of the Autoencoder and evaluate performances of the MNIST reconstruction. 
This method can explain how network works with different level of noise or different values of hyperparameters because feedback is not retrieved using a test set but directly obtained by the supervised classifier. In Fig.\ref{changingNoise} we can see how our autoencoder behaves using different threshold of noise w.r.t accuracy of the CNN classifier. 

\subsection*{Latent Space exploration (t-SNE)}
t-SNE is a powerful algorithm in order to visualize complex data representation into a simpler model. This method is useful for clustering tasks and analyze major components of the dataset.  In our homework, we implemented an \textit{hook} which is attached to the last linear layer of the encoder in order to obtain all the possible combinations of latent space (so the whole representation of the test set). In this manner, we have $10,000\times8$ which we have to convert into a $10,000\times2$ in order to analyze them in a graphical way. Thanks to the method of \textit{sklearn.manifold.TSNE} and the hook which retrieves all the output values, we are able to reduce dimensionality and see how representations of written numbers are codified into the autoencoder. We can see from Fig.\ref{tSNE} that images with the same number belongs to the same cluster (apart from some exception of false-positive samples).  


\begin{figure}[h!]
\centering
\includegraphics[scale = 0.15]{figures/tSNE}
\caption{t-SNE applied to normal samples.}
\label{tSNE}
\end{figure}

In the Appendix there are two t-SNE screenshots of each different environment with higher resolution for visualization purposes. In Fig.\ref{NoisytSNE} we can inspect a t-SNE apply to the case where input samples are noisy. Main difference w.r.t. the non-noisy case is that clusters are closer with each other so possibility of missreconstruction depends on the input noise. 

\subsection*{GAN - Generation of new MNIST samples}
\textbf{GAN} is a Neural Netword composed of two main modules: \textbf{Generator} which creates fake samples from a latent space (sampled using a Normal Distribution so $z\sim N(0,1)$) and a \textbf{Discriminator} which is trained in order to identify real and false MNIST images. Hence, the two Neural Networks are linked and trained together at the same speed in order to obtain high resolution fake images. Its structure has a game-theoretic perspective where the Discriminator and the Generator try to overcome each other. In order to implement the GAN, we use the code for the previous Autoencoder (Encoder $\rightarrow$ Discriminator with latent space dimensionality = $1$,  Decoder $\rightarrow$ Generator with input latent space set to $100$ normal samples) but with some modifications:
\begin{itemize}
\item Instead of using ReLU activation function, we apply LeakyReLU in order not to stop the Generator (Decoder in this case) in local minima;
\item Dropout is applied to Discriminator in order to train the two network at the same speed. If Discriminator is too strong (detect correctly every sample from the Generator), no variations occur during the training. Since Discriminator outputs a probability, a Sigmoid activation function is applied;
\item Generator generates double the number of random pictures and then evaluated from the Discirminator in order to speed up learning process.
\end{itemize}

These modifications are applied since it seems that most of the time Discriminator was overperforming w.r.t. Generator, causing \textbf{Gradient Vanishing}.

Denoting $\mathit{G()}$ the output of the Generator (an image) and $\mathit{D()}$ the output of the Discriminator (a probability with $1$ to real images and $0$ to fake ones), system can be modelled as a \textbf{minmax} Nash equilibrium:
\begin{equation}\label{GANeq}
\begin{split}
\min_{G}\max_{D} V(D,G) = \underbrace{\mathbb{E}_{\mathbf{x}\sim p_{data(\mathbf{x})}} [log D(\mathbf{x})]}_{\mathrm{Discriminator  Loss}}+ \\
 \underbrace{\mathbb{E}_{\mathbf{x}\sim p_z}[log(1-D(G(\mathbf{z}))]}_{\mathrm{Generator Loss}}
\end{split}
\end{equation}

\begin{figure}[h!]
\centering
\includegraphics[scale = 0.4]{figures/GAN150Epoch}
\caption{GAN samples at epoch $150$.}
\label{GAN150Epoch}
\end{figure}

Differently from the previous methods, we use the Binary Cross Entropy Loss in order to train together the two neural networks and create such competition between them (i.e. implementing Eq.\ref{GANeq}). For each sample in a batch we perform:
\begin{equation}
l_n = y_n \cdot log(x_n) + (1 - y_n)log(1 -x_n) \quad \forall n \in [0, \mathrm{batch\_size}]
\end{equation}
where $y_n$ denotes if an image is real or fake (assigning zeros or ones) and $x_n$ is the under study image.  In this manner, we can train together Discriminator (feeding labelled real and fake images and perform forward and backward propagation) and then notify the Generator on how its samples are classified by the Discriminator (returning the probability of being real).  The original equation has also a $w_n$ which is a manual rescaling weight given to the loss of each batch element. In this case, we set to $1$ for each batch element.

Thanks to this powerful architecture, we can obtain some good fake images which are shown in Fig.\ref{GAN150Epoch} at epoch $150$. We can notice that our GAN performs achievable results recreating numbers like $9$ or $8$ but struggles with numbers like $0$ and $3$.


\section*{Appendix}
\onecolumn

\begin{figure}[h!]
\centering
\includegraphics[scale = 0.3]{figures/tSNE}
\caption{t-SNE applied to normal samples.}

\end{figure}

\begin{figure}[h!]
\centering
\includegraphics[scale = 0.3]{figures/NoisytSNE}
\caption{t-SNE applied to noisy samples.}
\label{NoisytSNE}
\end{figure}

\begin{figure}[ht]%
 \centering
 \subfloat[]{\includegraphics[scale = 0.4]{figures/VariGAuss}\label{VariGAuss}}%
 \subfloat[]{\includegraphics[scale = 0.4]{figures/MeanGauss}\label{MeanGauss}}\\
 \subfloat[]{\includegraphics[scale = 0.4]{figures/probZeroMAsk}\label{probZeroMAsk}}%
 \caption{Different behaviours with different threshold of noise. (a) Variance of the Gaussian (b) Mean of the Gaussian (c) Probability of Zero Mask.}%
 \label{changingNoise}%
\end{figure}


\begin{figure}[h!]
\centering
\includegraphics[scale = 0.4]{figures/GAN100Epoch}
\caption{GAN samples at epoch $100$.}
\label{GAN100Epoch}
\end{figure}

\begin{figure}[h!]
\centering
\includegraphics[scale = 0.4]{figures/GAN50Epoch}
\caption{GAN samples at epoch $50$.}
\label{GAN50Epoch}
\end{figure}

\begin{figure}[h!]
\centering
\includegraphics[scale = 0.4]{figures/GAN0Epoch}
\caption{GAN samples at epoch $0$.}
\label{GAN0Epoch}
\end{figure}




%%%%%%%%%%%%%%% GUIDA %%%%%%%%%%%%%%%%%%%%%

%\section{Codice \textsc{Matlab}}

%\lstinputlisting{Tesina2018SS.m}


\end{document}


\endinput
